
#import "b4i_httputils2service.h"
#import "b4i_main.h"
#import "b4i_iisapicall.h"
#import "b4i_httpjob.h"


@implementation b4i_httputils2service 


+ (instancetype)new {
    static b4i_httputils2service* shared = nil;
    if (shared == nil) {
        shared = [self alloc];
        shared.bi = [[B4IShellBI alloc] init:shared];
        shared.__c = [B4ICommon new];
    }
    return shared;
}
- (int)debugAppId {
    return 31;
}


- (NSString*)  _completejob:(int) _taskid :(BOOL) _success :(NSString*) _errormessage :(B4IHttpResponse*) _res{
B4IRDebugUtils.currentModule=@"httputils2service";
if ([B4IDebug shouldDelegate: @"completejob"])
	 {return ((NSString*) [B4IDebug delegate:self.bi :@"completejob::::" :@[@(_taskid),@(_success),[B4I nilToNSNull:_errormessage],[B4I nilToNSNull:_res]]]);}
b4i_httpjob* _job = nil;
B4IRDebugUtils.currentLine=589824;
 //BA.debugLineNum = 589824;BA.debugLine="Sub CompleteJob(TaskId As Int, success As Boolean,";
B4IRDebugUtils.currentLine=589826;
 //BA.debugLineNum = 589826;BA.debugLine="Dim job As HttpJob = TaskIdToJob.Get(TaskId)";
_job = (b4i_httpjob*)([self->__taskidtojob Get:(NSObject*)(@(_taskid))]);
B4IRDebugUtils.currentLine=589827;
 //BA.debugLineNum = 589827;BA.debugLine="TaskIdToJob.Remove(TaskId)";
[self->__taskidtojob Remove:(NSObject*)(@(_taskid))];
B4IRDebugUtils.currentLine=589828;
 //BA.debugLineNum = 589828;BA.debugLine="job.success = success";
_job->__success = _success;
B4IRDebugUtils.currentLine=589829;
 //BA.debugLineNum = 589829;BA.debugLine="job.errorMessage = errorMessage";
_job->__errormessage = _errormessage;
B4IRDebugUtils.currentLine=589833;
 //BA.debugLineNum = 589833;BA.debugLine="job.Complete(res)";
[_job _complete:nil :_res];
B4IRDebugUtils.currentLine=589835;
 //BA.debugLineNum = 589835;BA.debugLine="End Sub";
return @"";
}
- (NSString*)  _hc_responseerror:(B4IHttpResponse*) _response :(NSString*) _reason :(int) _statuscode :(int) _taskid{
B4IRDebugUtils.currentModule=@"httputils2service";
if ([B4IDebug shouldDelegate: @"hc_responseerror"])
	 {return ((NSString*) [B4IDebug delegate:self.bi :@"hc_responseerror::::" :@[[B4I nilToNSNull:_response],[B4I nilToNSNull:_reason],@(_statuscode),@(_taskid)]]);}
B4IRDebugUtils.currentLine=458752;
 //BA.debugLineNum = 458752;BA.debugLine="Sub hc_ResponseError (Response As HttpResponse, Re";
B4IRDebugUtils.currentLine=458753;
 //BA.debugLineNum = 458753;BA.debugLine="Log(\"ResponseError: \" & Reason & \", status code:";
[self->___c LogImpl:@"9458753" :[@[@"ResponseError: ",_reason,@", status code: ",[self.bi NumberToString:@(_statuscode)]] componentsJoinedByString:@""] :0];
B4IRDebugUtils.currentLine=458754;
 //BA.debugLineNum = 458754;BA.debugLine="CompleteJob(TaskId, False, Reason, Response)";
[self _completejob:_taskid :false :_reason :_response];
B4IRDebugUtils.currentLine=458755;
 //BA.debugLineNum = 458755;BA.debugLine="End Sub";
return @"";
}
- (NSString*)  _hc_responsesuccess:(B4IHttpResponse*) _response :(int) _taskid{
B4IRDebugUtils.currentModule=@"httputils2service";
if ([B4IDebug shouldDelegate: @"hc_responsesuccess"])
	 {return ((NSString*) [B4IDebug delegate:self.bi :@"hc_responsesuccess::" :@[[B4I nilToNSNull:_response],@(_taskid)]]);}
B4IRDebugUtils.currentLine=524288;
 //BA.debugLineNum = 524288;BA.debugLine="Sub hc_ResponseSuccess (Response As HttpResponse,";
B4IRDebugUtils.currentLine=524289;
 //BA.debugLineNum = 524289;BA.debugLine="CompleteJob(TaskId, True, \"\", Response)";
[self _completejob:_taskid :true :@"" :_response];
B4IRDebugUtils.currentLine=524290;
 //BA.debugLineNum = 524290;BA.debugLine="End Sub";
return @"";
}
- (NSString*)  _process_globals{
self->__main=[b4i_main new];
B4IRDebugUtils.currentModule=@"httputils2service";
if ([B4IDebug shouldDelegate: @"process_globals"])
	 {return ((NSString*) [B4IDebug delegate:self.bi :@"process_globals" :nil]);}
B4IRDebugUtils.currentLine=262144;
 //BA.debugLineNum = 262144;BA.debugLine="Sub Process_Globals";
B4IRDebugUtils.currentLine=262148;
 //BA.debugLineNum = 262148;BA.debugLine="Private hc As HttpClient";
self->__hc = [B4IHttp new];
B4IRDebugUtils.currentLine=262150;
 //BA.debugLineNum = 262150;BA.debugLine="Private TaskIdToJob As Map";
self->__taskidtojob = [B4IMap new];
B4IRDebugUtils.currentLine=262151;
 //BA.debugLineNum = 262151;BA.debugLine="Public TempFolder As String";
self->__tempfolder = @"";
B4IRDebugUtils.currentLine=262152;
 //BA.debugLineNum = 262152;BA.debugLine="Private taskCounter As Int";
self->__taskcounter = 0;
B4IRDebugUtils.currentLine=262153;
 //BA.debugLineNum = 262153;BA.debugLine="End Sub";
return @"";
}
- (NSString*)  _service_create{
B4IRDebugUtils.currentModule=@"httputils2service";
if ([B4IDebug shouldDelegate: @"service_create"])
	 {return ((NSString*) [B4IDebug delegate:self.bi :@"service_create" :nil]);}
B4IRDebugUtils.currentLine=327680;
 //BA.debugLineNum = 327680;BA.debugLine="Sub Service_Create";
B4IRDebugUtils.currentLine=327695;
 //BA.debugLineNum = 327695;BA.debugLine="hc.Initialize(\"hc\")";
[self->__hc Initialize:self.bi :@"hc"];
B4IRDebugUtils.currentLine=327696;
 //BA.debugLineNum = 327696;BA.debugLine="TaskIdToJob.Initialize";
[self->__taskidtojob Initialize];
B4IRDebugUtils.currentLine=327697;
 //BA.debugLineNum = 327697;BA.debugLine="End Sub";
return @"";
}
- (NSString*)  _submitjob:(b4i_httpjob*) _job{
B4IRDebugUtils.currentModule=@"httputils2service";
if ([B4IDebug shouldDelegate: @"submitjob"])
	 {return ((NSString*) [B4IDebug delegate:self.bi :@"submitjob:" :@[[B4I nilToNSNull:_job]]]);}
B4IRDebugUtils.currentLine=393216;
 //BA.debugLineNum = 393216;BA.debugLine="Public Sub SubmitJob(job As HttpJob)";
B4IRDebugUtils.currentLine=393217;
 //BA.debugLineNum = 393217;BA.debugLine="If hc.IsInitialized = False Then Service_Create";
if ([self->__hc IsInitialized]==false) { 
[self _service_create];};
B4IRDebugUtils.currentLine=393218;
 //BA.debugLineNum = 393218;BA.debugLine="taskCounter = taskCounter + 1";
self->__taskcounter = (int) (self->__taskcounter+1);
B4IRDebugUtils.currentLine=393219;
 //BA.debugLineNum = 393219;BA.debugLine="TaskIdToJob.Put(taskCounter, job)";
[self->__taskidtojob Put:(NSObject*)(@(self->__taskcounter)) :(NSObject*)(_job)];
B4IRDebugUtils.currentLine=393220;
 //BA.debugLineNum = 393220;BA.debugLine="If job.Username <> \"\" And job.Password <> \"\" Then";
if ([_job->__username isEqual:@""] == false && [_job->__password isEqual:@""] == false) { 
B4IRDebugUtils.currentLine=393221;
 //BA.debugLineNum = 393221;BA.debugLine="hc.ExecuteCredentials(job.GetRequest, taskCounte";
[self->__hc ExecuteCredentials:[_job _getrequest:nil] :self->__taskcounter :_job->__username :_job->__password];
 }else {
B4IRDebugUtils.currentLine=393223;
 //BA.debugLineNum = 393223;BA.debugLine="hc.Execute(job.GetRequest, taskCounter)";
[self->__hc Execute:[_job _getrequest:nil] :self->__taskcounter];
 };
B4IRDebugUtils.currentLine=393225;
 //BA.debugLineNum = 393225;BA.debugLine="End Sub";
return @"";
}
@end