
#import "b4i_iisapicall.h"
#import "b4i_main.h"
#import "b4i_httputils2service.h"
#import "b4i_httpjob.h"


@implementation b4i_iisapicall 


+ (B4I*)createBI {
    return [B4IShellBI alloc];
}

- (void)dealloc {
    if (self.bi != nil)
        NSLog(@"Class (b4i_iisapicall) instance released.");
}

- (NSString*)  _initialize:(b4i_iisapicall*) __ref :(B4I*) _ba :(NSString*) _root :(NSString*) _script :(NSString*) _query :(B4IMap*) _customheader :(NSString*) _jobname :(NSObject*) _sourcetarget1{
__ref = self;
[self initializeClassModule];
B4IRDebugUtils.currentModule=@"iisapicall";
if ([B4IDebug shouldDelegate: @"initialize"])
	 {return ((NSString*) [B4IDebug delegate:self.bi :@"initialize:::::::" :@[[B4I nilToNSNull:_ba],[B4I nilToNSNull:_root],[B4I nilToNSNull:_script],[B4I nilToNSNull:_query],[B4I nilToNSNull:_customheader],[B4I nilToNSNull:_jobname],[B4I nilToNSNull:_sourcetarget1]]]);}
b4i_httpjob* _job = nil;
B4IRDebugUtils.currentLine=2359296;
 //BA.debugLineNum = 2359296;BA.debugLine="Public Sub Initialize (root As String, script As S";
B4IRDebugUtils.currentLine=2359298;
 //BA.debugLineNum = 2359298;BA.debugLine="Dim job As HttpJob";
_job = [b4i_httpjob new];
B4IRDebugUtils.currentLine=2359300;
 //BA.debugLineNum = 2359300;BA.debugLine="SourceTarget = SourceTarget1";
__ref->__sourcetarget = _sourcetarget1;
B4IRDebugUtils.currentLine=2359301;
 //BA.debugLineNum = 2359301;BA.debugLine="job.Initialize(JobName, Me)";
[_job _initialize:nil :self.bi :_jobname :self];
B4IRDebugUtils.currentLine=2359302;
 //BA.debugLineNum = 2359302;BA.debugLine="rootCache = root";
__ref->__rootcache = _root;
B4IRDebugUtils.currentLine=2359303;
 //BA.debugLineNum = 2359303;BA.debugLine="scriptCache = script";
__ref->__scriptcache = _script;
B4IRDebugUtils.currentLine=2359304;
 //BA.debugLineNum = 2359304;BA.debugLine="QueryCache = Query";
__ref->__querycache = _query;
B4IRDebugUtils.currentLine=2359307;
 //BA.debugLineNum = 2359307;BA.debugLine="CustomHeaderCache = CustomHeader";
__ref->__customheadercache = _customheader;
B4IRDebugUtils.currentLine=2359309;
 //BA.debugLineNum = 2359309;BA.debugLine="If IIS_Busy = False Then";
if (__ref->__iis_busy==false) { 
B4IRDebugUtils.currentLine=2359310;
 //BA.debugLineNum = 2359310;BA.debugLine="ExecuteQuery(job, rootCache, scriptCache, QueryC";
[__ref _executequery:nil :_job :__ref->__rootcache :__ref->__scriptcache :__ref->__querycache :__ref->__customheadercache];
 };
B4IRDebugUtils.currentLine=2359312;
 //BA.debugLineNum = 2359312;BA.debugLine="End Sub";
return @"";
}
- (BOOL)  _isinerror:(b4i_iisapicall*) __ref{
__ref = self;
B4IRDebugUtils.currentModule=@"iisapicall";
if ([B4IDebug shouldDelegate: @"isinerror"])
	 {return ((NSNumber*) [B4IDebug delegate:self.bi :@"isinerror" :nil]).boolValue;}
B4IRDebugUtils.currentLine=2752512;
 //BA.debugLineNum = 2752512;BA.debugLine="Sub IsInError As Boolean";
B4IRDebugUtils.currentLine=2752513;
 //BA.debugLineNum = 2752513;BA.debugLine="Return Errore > 0";
if (true) return __ref->__errore>0;
B4IRDebugUtils.currentLine=2752514;
 //BA.debugLineNum = 2752514;BA.debugLine="End Sub";
return false;
}
- (B4IMap*)  _givemedata:(b4i_iisapicall*) __ref{
__ref = self;
B4IRDebugUtils.currentModule=@"iisapicall";
if ([B4IDebug shouldDelegate: @"givemedata"])
	 {return ((B4IMap*) [B4IDebug delegate:self.bi :@"givemedata" :nil]);}
B4IRDebugUtils.currentLine=2686976;
 //BA.debugLineNum = 2686976;BA.debugLine="Sub GiveMeData As Map";
B4IRDebugUtils.currentLine=2686978;
 //BA.debugLineNum = 2686978;BA.debugLine="Return Data";
if (true) return __ref->__data;
B4IRDebugUtils.currentLine=2686980;
 //BA.debugLineNum = 2686980;BA.debugLine="End Sub";
return nil;
}
- (NSString*)  _class_globals:(b4i_iisapicall*) __ref{
__ref = self;
self->__main=[b4i_main new];
self->__httputils2service=[b4i_httputils2service new];
B4IRDebugUtils.currentModule=@"iisapicall";
B4IRDebugUtils.currentLine=2293760;
 //BA.debugLineNum = 2293760;BA.debugLine="Sub Class_Globals";
B4IRDebugUtils.currentLine=2293761;
 //BA.debugLineNum = 2293761;BA.debugLine="Dim SourceTarget As Object";
self->__sourcetarget = [NSObject new];
B4IRDebugUtils.currentLine=2293762;
 //BA.debugLineNum = 2293762;BA.debugLine="Private Errore As Byte";
self->__errore = 0;
B4IRDebugUtils.currentLine=2293763;
 //BA.debugLineNum = 2293763;BA.debugLine="Private Data As Map";
self->__data = [B4IMap new];
B4IRDebugUtils.currentLine=2293764;
 //BA.debugLineNum = 2293764;BA.debugLine="Dim Num_tentativi As Byte";
self->__num_tentativi = 0;
B4IRDebugUtils.currentLine=2293767;
 //BA.debugLineNum = 2293767;BA.debugLine="Dim rootCache As String";
self->__rootcache = @"";
B4IRDebugUtils.currentLine=2293768;
 //BA.debugLineNum = 2293768;BA.debugLine="Dim scriptCache As String";
self->__scriptcache = @"";
B4IRDebugUtils.currentLine=2293769;
 //BA.debugLineNum = 2293769;BA.debugLine="Dim QueryCache As String";
self->__querycache = @"";
B4IRDebugUtils.currentLine=2293772;
 //BA.debugLineNum = 2293772;BA.debugLine="Private  CustomHeaderCache As Map";
self->__customheadercache = [B4IMap new];
B4IRDebugUtils.currentLine=2293774;
 //BA.debugLineNum = 2293774;BA.debugLine="Private RxHeader As Map 'header rx from WebApi";
self->__rxheader = [B4IMap new];
B4IRDebugUtils.currentLine=2293776;
 //BA.debugLineNum = 2293776;BA.debugLine="Private IIS_Busy As Boolean = False";
self->__iis_busy = false;
B4IRDebugUtils.currentLine=2293777;
 //BA.debugLineNum = 2293777;BA.debugLine="End Sub";
return @"";
}
- (NSString*)  _executequery:(b4i_iisapicall*) __ref :(b4i_httpjob*) _job :(NSString*) _root :(NSString*) _script :(NSString*) _query :(B4IMap*) _customheader{
__ref = self;
B4IRDebugUtils.currentModule=@"iisapicall";
if ([B4IDebug shouldDelegate: @"executequery"])
	 {return ((NSString*) [B4IDebug delegate:self.bi :@"executequery:::::" :@[[B4I nilToNSNull:_job],[B4I nilToNSNull:_root],[B4I nilToNSNull:_script],[B4I nilToNSNull:_query],[B4I nilToNSNull:_customheader]]]);}
NSString* _key = @"";
B4IRDebugUtils.currentLine=2424832;
 //BA.debugLineNum = 2424832;BA.debugLine="Sub ExecuteQuery(job As HttpJob, root As String, s";
B4IRDebugUtils.currentLine=2424834;
 //BA.debugLineNum = 2424834;BA.debugLine="IIS_Busy = True";
__ref->__iis_busy = true;
B4IRDebugUtils.currentLine=2424836;
 //BA.debugLineNum = 2424836;BA.debugLine="job.PostString(root & script , Query)";
[_job _poststring:nil :[@[_root,_script] componentsJoinedByString:@""] :_query];
B4IRDebugUtils.currentLine=2424837;
 //BA.debugLineNum = 2424837;BA.debugLine="job.GetRequest.Timeout = 25000";
[[_job _getrequest:nil] setTimeout:(int) (25000)];
B4IRDebugUtils.currentLine=2424840;
 //BA.debugLineNum = 2424840;BA.debugLine="If CustomHeader.IsInitialized Then";
if ([_customheader IsInitialized]) { 
B4IRDebugUtils.currentLine=2424841;
 //BA.debugLineNum = 2424841;BA.debugLine="If CustomHeader.Size > 0 Then";
if ([_customheader Size]>0) { 
B4IRDebugUtils.currentLine=2424850;
 //BA.debugLineNum = 2424850;BA.debugLine="For Each key As String In CustomHeader.Keys";
{
const id<B4IIterable> group6 = [_customheader Keys];
const int groupLen6 = group6.Size
;int index6 = 0;
;
for (; index6 < groupLen6;index6++){
_key = [self.bi ObjectToString:[group6 Get:index6]];
B4IRDebugUtils.currentLine=2424851;
 //BA.debugLineNum = 2424851;BA.debugLine="job.GetRequest.SetHeader(key, CustomHeader.Ge";
[[_job _getrequest:nil] SetHeader:_key :[self.bi ObjectToString:[_customheader Get:(NSObject*)(_key)]]];
 }
};
 };
 };
B4IRDebugUtils.currentLine=2424857;
 //BA.debugLineNum = 2424857;BA.debugLine="End Sub";
return @"";
}
- (NSString*)  _getdata:(b4i_iisapicall*) __ref :(NSString*) _result{
__ref = self;
B4IRDebugUtils.currentModule=@"iisapicall";
if ([B4IDebug shouldDelegate: @"getdata"])
	 {return ((NSString*) [B4IDebug delegate:self.bi :@"getdata:" :@[[B4I nilToNSNull:_result]]]);}
B4IJSONParser* _json = nil;
B4IMap* _map1 = nil;
B4IJSONGenerator* _a = nil;
B4IMap* _maperror = nil;
B4IMap* _mapnottraperr = nil;
B4IMap* _nottraperr = nil;
B4IRDebugUtils.currentLine=2621440;
 //BA.debugLineNum = 2621440;BA.debugLine="Sub GetData (Result As String)";
B4IRDebugUtils.currentLine=2621442;
 //BA.debugLineNum = 2621442;BA.debugLine="Dim Json As JSONParser";
_json = [B4IJSONParser new];
B4IRDebugUtils.currentLine=2621443;
 //BA.debugLineNum = 2621443;BA.debugLine="Dim Map1 As Map";
_map1 = [B4IMap new];
B4IRDebugUtils.currentLine=2621445;
 //BA.debugLineNum = 2621445;BA.debugLine="Log(\"WebApi_RxData: = \" & Result)";
[self->___c LogImpl:@"42621445" :[@[@"WebApi_RxData: = ",_result] componentsJoinedByString:@""] :0];
B4IRDebugUtils.currentLine=2621446;
 //BA.debugLineNum = 2621446;BA.debugLine="Json.Initialize(Result)";
[_json Initialize:_result];
B4IRDebugUtils.currentLine=2621447;
 //BA.debugLineNum = 2621447;BA.debugLine="Map1 = Json.NextObject";
_map1 = [_json NextObject];
B4IRDebugUtils.currentLine=2621448;
 //BA.debugLineNum = 2621448;BA.debugLine="Data = Map1.Get(\"Data\")";
__ref->__data = (B4IMap*)([_map1 Get:(NSObject*)(@"Data")]);
B4IRDebugUtils.currentLine=2621449;
 //BA.debugLineNum = 2621449;BA.debugLine="If Map1.ContainsKey(\"Version\") Then";
if ([_map1 ContainsKey:(NSObject*)(@"Version")]) { 
B4IRDebugUtils.currentLine=2621450;
 //BA.debugLineNum = 2621450;BA.debugLine="Log( Map1.Get(\"Version\"))";
[self->___c LogImpl:@"42621450" :[self.bi ObjectToString:[_map1 Get:(NSObject*)(@"Version")]] :0];
B4IRDebugUtils.currentLine=2621452;
 //BA.debugLineNum = 2621452;BA.debugLine="Dim a As JSONGenerator";
_a = [B4IJSONGenerator new];
B4IRDebugUtils.currentLine=2621454;
 //BA.debugLineNum = 2621454;BA.debugLine="a.Initialize(Map1)";
[_a Initialize:_map1];
B4IRDebugUtils.currentLine=2621456;
 //BA.debugLineNum = 2621456;BA.debugLine="Log(a.ToString)";
[self->___c LogImpl:@"42621456" :[_a ToString] :0];
 };
B4IRDebugUtils.currentLine=2621459;
 //BA.debugLineNum = 2621459;BA.debugLine="Dim MapError As Map = Map1.Get(\"NotTrappedError\")";
_maperror = (B4IMap*)([_map1 Get:(NSObject*)(@"NotTrappedError")]);
B4IRDebugUtils.currentLine=2621461;
 //BA.debugLineNum = 2621461;BA.debugLine="Try";
@try {B4IRDebugUtils.currentLine=2621462;
 //BA.debugLineNum = 2621462;BA.debugLine="If MapError.IsInitialized Then";
if ([_maperror IsInitialized]) { 
B4IRDebugUtils.currentLine=2621463;
 //BA.debugLineNum = 2621463;BA.debugLine="Dim MapNotTrapErr As Map = MapError.Get(\"Error\"";
_mapnottraperr = (B4IMap*)([_maperror Get:(NSObject*)(@"Error")]);
B4IRDebugUtils.currentLine=2621464;
 //BA.debugLineNum = 2621464;BA.debugLine="If MapNotTrapErr <> Null Then";
if (_mapnottraperr!= nil) { 
B4IRDebugUtils.currentLine=2621465;
 //BA.debugLineNum = 2621465;BA.debugLine="If MapNotTrapErr.IsInitialized Then";
if ([_mapnottraperr IsInitialized]) { 
B4IRDebugUtils.currentLine=2621466;
 //BA.debugLineNum = 2621466;BA.debugLine="Log(\"WebAPI Error1: \" & Map1.Get(\"NotAuthoriz";
[self->___c LogImpl:@"42621466" :[@[@"WebAPI Error1: ",[self.bi ObjectToString:[_map1 Get:(NSObject*)(@"NotAuthorized")]]] componentsJoinedByString:@""] :0];
B4IRDebugUtils.currentLine=2621467;
 //BA.debugLineNum = 2621467;BA.debugLine="Log(\"WebAPI Error2: \" & Map1.Get(\"NotTrappedE";
[self->___c LogImpl:@"42621467" :[@[@"WebAPI Error2: ",[self.bi ObjectToString:[_map1 Get:(NSObject*)(@"NotTrappedError")]]] componentsJoinedByString:@""] :0];
B4IRDebugUtils.currentLine=2621469;
 //BA.debugLineNum = 2621469;BA.debugLine="Errore = 1";
__ref->__errore = (unsigned char) (1);
B4IRDebugUtils.currentLine=2621471;
 //BA.debugLineNum = 2621471;BA.debugLine="Dim NotTrapErr As Map";
_nottraperr = [B4IMap new];
B4IRDebugUtils.currentLine=2621472;
 //BA.debugLineNum = 2621472;BA.debugLine="NotTrapErr = Map1.Get(\"NotTrappedError\")";
_nottraperr = (B4IMap*)([_map1 Get:(NSObject*)(@"NotTrappedError")]);
 };
 };
 };
 } 
       @catch (NSException* e28) {
			[B4I SetException:e28];B4IRDebugUtils.currentLine=2621480;
 //BA.debugLineNum = 2621480;BA.debugLine="IIS_Busy = False";
__ref->__iis_busy = false;
 };
B4IRDebugUtils.currentLine=2621483;
 //BA.debugLineNum = 2621483;BA.debugLine="Try";
@try {B4IRDebugUtils.currentLine=2621485;
 //BA.debugLineNum = 2621485;BA.debugLine="If Map1.Get(\"NotAuthorizedVersion\") <> Null Then";
if ([_map1 Get:(NSObject*)(@"NotAuthorizedVersion")]!= nil) { 
B4IRDebugUtils.currentLine=2621486;
 //BA.debugLineNum = 2621486;BA.debugLine="If Map1.Get(\"NotAuthorizedVersion\") = True Then";
if ([[_map1 Get:(NSObject*)(@"NotAuthorizedVersion")] isEqual:(NSObject*)(@(true))]) { 
B4IRDebugUtils.currentLine=2621487;
 //BA.debugLineNum = 2621487;BA.debugLine="Errore = 4";
__ref->__errore = (unsigned char) (4);
 };
 };
 } 
       @catch (NSException* e37) {
			[B4I SetException:e37];B4IRDebugUtils.currentLine=2621491;
 //BA.debugLineNum = 2621491;BA.debugLine="Log(\"IIS Error Compatibility version\")";
[self->___c LogImpl:@"42621491" :@"IIS Error Compatibility version" :0];
B4IRDebugUtils.currentLine=2621492;
 //BA.debugLineNum = 2621492;BA.debugLine="IIS_Busy = False";
__ref->__iis_busy = false;
 };
B4IRDebugUtils.currentLine=2621495;
 //BA.debugLineNum = 2621495;BA.debugLine="IIS_Busy = False";
__ref->__iis_busy = false;
B4IRDebugUtils.currentLine=2621496;
 //BA.debugLineNum = 2621496;BA.debugLine="End Sub";
return @"";
}
- (NSString*)  _getheaderkeyvalue:(b4i_iisapicall*) __ref :(NSString*) _key{
__ref = self;
B4IRDebugUtils.currentModule=@"iisapicall";
if ([B4IDebug shouldDelegate: @"getheaderkeyvalue"])
	 {return ((NSString*) [B4IDebug delegate:self.bi :@"getheaderkeyvalue:" :@[[B4I nilToNSNull:_key]]]);}
NSString* _result = @"";
B4IRDebugUtils.currentLine=2949120;
 //BA.debugLineNum = 2949120;BA.debugLine="Sub GetHeaderKeyValue(Key As String) As String";
B4IRDebugUtils.currentLine=2949122;
 //BA.debugLineNum = 2949122;BA.debugLine="Dim result As String = \"\"";
_result = @"";
B4IRDebugUtils.currentLine=2949124;
 //BA.debugLineNum = 2949124;BA.debugLine="If RxHeader.IsInitialized Then";
if ([__ref->__rxheader IsInitialized]) { 
B4IRDebugUtils.currentLine=2949125;
 //BA.debugLineNum = 2949125;BA.debugLine="result = RxHeader.GetDefault(Key,\"\")";
_result = [self.bi ObjectToString:[__ref->__rxheader GetDefault:(NSObject*)(_key) :(NSObject*)(@"")]];
 };
B4IRDebugUtils.currentLine=2949128;
 //BA.debugLineNum = 2949128;BA.debugLine="Return result";
if (true) return _result;
B4IRDebugUtils.currentLine=2949130;
 //BA.debugLineNum = 2949130;BA.debugLine="End Sub";
return @"";
}
- (BOOL)  _isbusy:(b4i_iisapicall*) __ref{
__ref = self;
B4IRDebugUtils.currentModule=@"iisapicall";
if ([B4IDebug shouldDelegate: @"isbusy"])
	 {return ((NSNumber*) [B4IDebug delegate:self.bi :@"isbusy" :nil]).boolValue;}
B4IRDebugUtils.currentLine=2818048;
 //BA.debugLineNum = 2818048;BA.debugLine="Sub IsBusy As Boolean";
B4IRDebugUtils.currentLine=2818049;
 //BA.debugLineNum = 2818049;BA.debugLine="Return IIS_Busy";
if (true) return __ref->__iis_busy;
B4IRDebugUtils.currentLine=2818050;
 //BA.debugLineNum = 2818050;BA.debugLine="End Sub";
return false;
}
- (NSString*)  _jobdone:(b4i_iisapicall*) __ref :(b4i_httpjob*) _jobname{
__ref = self;
B4IRDebugUtils.currentModule=@"iisapicall";
if ([B4IDebug shouldDelegate: @"jobdone"])
	 {return ((NSString*) [B4IDebug delegate:self.bi :@"jobdone:" :@[[B4I nilToNSNull:_jobname]]]);}
B4IRDebugUtils.currentLine=2490368;
 //BA.debugLineNum = 2490368;BA.debugLine="Sub JobDone (jobName As HttpJob)";
B4IRDebugUtils.currentLine=2490372;
 //BA.debugLineNum = 2490372;BA.debugLine="If jobName.Success = True Then";
if (_jobname->__success==true) { 
B4IRDebugUtils.currentLine=2490374;
 //BA.debugLineNum = 2490374;BA.debugLine="Errore = 0";
__ref->__errore = (unsigned char) (0);
B4IRDebugUtils.currentLine=2490375;
 //BA.debugLineNum = 2490375;BA.debugLine="GetData(jobName.GetString)";
[__ref _getdata:nil :[_jobname _getstring:nil]];
B4IRDebugUtils.currentLine=2490377;
 //BA.debugLineNum = 2490377;BA.debugLine="If Errore  = 1 Then";
if (__ref->__errore==1) { 
B4IRDebugUtils.currentLine=2490378;
 //BA.debugLineNum = 2490378;BA.debugLine="RetryExecuteQuery(jobName)";
[__ref _retryexecutequery:nil :_jobname];
 };
 }else {
B4IRDebugUtils.currentLine=2490382;
 //BA.debugLineNum = 2490382;BA.debugLine="Log(\"ISS JOB Error: \" & jobName.ErrorMessage)";
[self->___c LogImpl:@"42490382" :[@[@"ISS JOB Error: ",_jobname->__errormessage] componentsJoinedByString:@""] :0];
B4IRDebugUtils.currentLine=2490384;
 //BA.debugLineNum = 2490384;BA.debugLine="Errore = 1";
__ref->__errore = (unsigned char) (1);
B4IRDebugUtils.currentLine=2490385;
 //BA.debugLineNum = 2490385;BA.debugLine="RetryExecuteQuery(jobName)";
[__ref _retryexecutequery:nil :_jobname];
 };
B4IRDebugUtils.currentLine=2490388;
 //BA.debugLineNum = 2490388;BA.debugLine="CallSub2(SourceTarget, \"IISAPIDone\" ,jobName.JobN";
[self->___c CallSubDebug2:self.bi :__ref->__sourcetarget :@"IISAPIDone" :(NSObject*)(_jobname->__jobname)];
B4IRDebugUtils.currentLine=2490390;
 //BA.debugLineNum = 2490390;BA.debugLine="jobName.Release";
[_jobname _release:nil];
B4IRDebugUtils.currentLine=2490392;
 //BA.debugLineNum = 2490392;BA.debugLine="IIS_Busy = False";
__ref->__iis_busy = false;
B4IRDebugUtils.currentLine=2490393;
 //BA.debugLineNum = 2490393;BA.debugLine="End Sub";
return @"";
}
- (NSString*)  _retryexecutequery:(b4i_iisapicall*) __ref :(b4i_httpjob*) _jobname{
__ref = self;
B4IRDebugUtils.currentModule=@"iisapicall";
if ([B4IDebug shouldDelegate: @"retryexecutequery"])
	 {return ((NSString*) [B4IDebug delegate:self.bi :@"retryexecutequery:" :@[[B4I nilToNSNull:_jobname]]]);}
B4IRDebugUtils.currentLine=2555904;
 //BA.debugLineNum = 2555904;BA.debugLine="Sub RetryExecuteQuery(jobName As HttpJob)";
B4IRDebugUtils.currentLine=2555906;
 //BA.debugLineNum = 2555906;BA.debugLine="Num_tentativi = Num_tentativi + 1";
__ref->__num_tentativi = (unsigned char) (__ref->__num_tentativi+1);
B4IRDebugUtils.currentLine=2555910;
 //BA.debugLineNum = 2555910;BA.debugLine="If Num_tentativi < 2 Then";
if (__ref->__num_tentativi<2) { 
B4IRDebugUtils.currentLine=2555912;
 //BA.debugLineNum = 2555912;BA.debugLine="ExecuteQuery(jobName, rootCache, scriptCache, Qu";
[__ref _executequery:nil :_jobname :__ref->__rootcache :__ref->__scriptcache :__ref->__querycache :__ref->__customheadercache];
 }else {
B4IRDebugUtils.currentLine=2555915;
 //BA.debugLineNum = 2555915;BA.debugLine="Num_tentativi = 0";
__ref->__num_tentativi = (unsigned char) (0);
 };
B4IRDebugUtils.currentLine=2555920;
 //BA.debugLineNum = 2555920;BA.debugLine="End Sub";
return @"";
}
- (NSString*)  _setbusyfalse:(b4i_iisapicall*) __ref{
__ref = self;
B4IRDebugUtils.currentModule=@"iisapicall";
if ([B4IDebug shouldDelegate: @"setbusyfalse"])
	 {return ((NSString*) [B4IDebug delegate:self.bi :@"setbusyfalse" :nil]);}
B4IRDebugUtils.currentLine=2883584;
 //BA.debugLineNum = 2883584;BA.debugLine="Sub SetBusyFalse";
B4IRDebugUtils.currentLine=2883585;
 //BA.debugLineNum = 2883585;BA.debugLine="IIS_Busy = False";
__ref->__iis_busy = false;
B4IRDebugUtils.currentLine=2883586;
 //BA.debugLineNum = 2883586;BA.debugLine="End Sub";
return @"";
}
@end