
#import "b4i_main.h"
#import "b4i_iisapicall.h"
#import "b4i_httputils2service.h"
#import "b4i_httpjob.h"


@implementation b4i_main 


+ (instancetype)new {
    static b4i_main* shared = nil;
    if (shared == nil) {
        shared = [self alloc];
        shared.bi = [[B4IShellBI alloc] init:shared];
        shared.__c = [B4ICommon new];
    }
    return shared;
}
- (int)debugAppId {
    return 31;
}


- (NSString*)  _application_background{
B4IRDebugUtils.currentModule=@"main";
if ([B4IDebug shouldDelegate: @"application_background"])
	 {return ((NSString*) [B4IDebug delegate:self.bi :@"application_background" :nil]);}
B4IRDebugUtils.currentLine=196608;
 //BA.debugLineNum = 196608;BA.debugLine="Private Sub Application_Background";
B4IRDebugUtils.currentLine=196610;
 //BA.debugLineNum = 196610;BA.debugLine="End Sub";
return @"";
}
- (NSString*)  _application_start:(B4INavigationControllerWrapper*) _nav{
B4IRDebugUtils.currentModule=@"main";
if ([B4IDebug shouldDelegate: @"application_start"])
	 {return ((NSString*) [B4IDebug delegate:self.bi :@"application_start:" :@[[B4I nilToNSNull:_nav]]]);}
B4IRDebugUtils.currentLine=65536;
 //BA.debugLineNum = 65536;BA.debugLine="Private Sub Application_Start (Nav As NavigationCo";
B4IRDebugUtils.currentLine=65543;
 //BA.debugLineNum = 65543;BA.debugLine="Log(\"insert url\")";
[self->___c LogImpl:@"465543" :@"insert url" :0];
B4IRDebugUtils.currentLine=65545;
 //BA.debugLineNum = 65545;BA.debugLine="IIS.Initialize(\"http://sdapi-dev.softex.local/\",";
[self->__iis _initialize:nil :self.bi :@"http://sdapi-dev.softex.local/" :@"/APIUtility/LoadPrerequisites" :[@[@"cultureStr=en-GB",[self _getauthbasequery]] componentsJoinedByString:@""] :[self _sethttpheader] :@"JobLoadPrerequisites" :self];
B4IRDebugUtils.currentLine=65547;
 //BA.debugLineNum = 65547;BA.debugLine="End Sub";
return @"";
}
- (NSString*)  _getauthbasequery{
B4IRDebugUtils.currentModule=@"main";
if ([B4IDebug shouldDelegate: @"getauthbasequery"])
	 {return ((NSString*) [B4IDebug delegate:self.bi :@"getauthbasequery" :nil]);}
B4IJSONGenerator* _json = nil;
B4IRDebugUtils.currentLine=3211264;
 //BA.debugLineNum = 3211264;BA.debugLine="Sub GetAuthBaseQuery As String";
B4IRDebugUtils.currentLine=3211266;
 //BA.debugLineNum = 3211266;BA.debugLine="Dim json As JSONGenerator";
_json = [B4IJSONGenerator new];
B4IRDebugUtils.currentLine=3211268;
 //BA.debugLineNum = 3211268;BA.debugLine="If WebApiAuthBase.IsInitialized = False Then";
if ([self->__webapiauthbase IsInitialized]==false) { 
B4IRDebugUtils.currentLine=3211269;
 //BA.debugLineNum = 3211269;BA.debugLine="InizializeWebApiAuthBase";
[self _inizializewebapiauthbase];
 };
B4IRDebugUtils.currentLine=3211272;
 //BA.debugLineNum = 3211272;BA.debugLine="json.Initialize(WebApiAuthBase)";
[_json Initialize:self->__webapiauthbase];
B4IRDebugUtils.currentLine=3211273;
 //BA.debugLineNum = 3211273;BA.debugLine="Log(json.ToString)";
[self->___c LogImpl:@"43211273" :[_json ToString] :0];
B4IRDebugUtils.currentLine=3211274;
 //BA.debugLineNum = 3211274;BA.debugLine="Return \"SDSettings=\" & json.ToString";
if (true) return [@[@"SDSettings=",[_json ToString]] componentsJoinedByString:@""];
B4IRDebugUtils.currentLine=3211275;
 //BA.debugLineNum = 3211275;BA.debugLine="End Sub";
return @"";
}
- (B4IMap*)  _sethttpheader{
B4IRDebugUtils.currentModule=@"main";
if ([B4IDebug shouldDelegate: @"sethttpheader"])
	 {return ((B4IMap*) [B4IDebug delegate:self.bi :@"sethttpheader" :nil]);}
B4IMap* _mappa = nil;
B4IRDebugUtils.currentLine=3407872;
 //BA.debugLineNum = 3407872;BA.debugLine="Sub SetHttpHeader As Map";
B4IRDebugUtils.currentLine=3407874;
 //BA.debugLineNum = 3407874;BA.debugLine="Dim mappa As Map";
_mappa = [B4IMap new];
B4IRDebugUtils.currentLine=3407876;
 //BA.debugLineNum = 3407876;BA.debugLine="mappa.Initialize";
[_mappa Initialize];
B4IRDebugUtils.currentLine=3407879;
 //BA.debugLineNum = 3407879;BA.debugLine="mappa.Put(\"Authorization\" ,\"Basic Q3VzdG9tUGludGV";
[_mappa Put:(NSObject*)(@"Authorization") :(NSObject*)(@"Basic Q3VzdG9tUGludGVyQ2FpcG9Tb2Z0d2FyZSE6Q3VzdG9tcGFzc1dvcmQ0UENTPw==")];
B4IRDebugUtils.currentLine=3407880;
 //BA.debugLineNum = 3407880;BA.debugLine="mappa.Put(\"callerType\" ,0)";
[_mappa Put:(NSObject*)(@"callerType") :(NSObject*)(@(0))];
B4IRDebugUtils.currentLine=3407882;
 //BA.debugLineNum = 3407882;BA.debugLine="Return mappa";
if (true) return _mappa;
B4IRDebugUtils.currentLine=3407884;
 //BA.debugLineNum = 3407884;BA.debugLine="End Sub";
return nil;
}
- (NSString*)  _inizializewebapiauthbase{
B4IRDebugUtils.currentModule=@"main";
if ([B4IDebug shouldDelegate: @"inizializewebapiauthbase"])
	 {return ((NSString*) [B4IDebug delegate:self.bi :@"inizializewebapiauthbase" :nil]);}
B4IRDebugUtils.currentLine=3276800;
 //BA.debugLineNum = 3276800;BA.debugLine="Sub InizializeWebApiAuthBase";
B4IRDebugUtils.currentLine=3276802;
 //BA.debugLineNum = 3276802;BA.debugLine="WebApiAuthBase.Initialize";
[self->__webapiauthbase Initialize];
B4IRDebugUtils.currentLine=3276803;
 //BA.debugLineNum = 3276803;BA.debugLine="WebApiAuthBase.Put(\"Culture\",\"en-GB\")";
[self->__webapiauthbase Put:(NSObject*)(@"Culture") :(NSObject*)(@"en-GB")];
B4IRDebugUtils.currentLine=3276804;
 //BA.debugLineNum = 3276804;BA.debugLine="WebApiAuthBase.Put(\"IsLogged\",False)";
[self->__webapiauthbase Put:(NSObject*)(@"IsLogged") :(NSObject*)(@(false))];
B4IRDebugUtils.currentLine=3276805;
 //BA.debugLineNum = 3276805;BA.debugLine="WebApiAuthBase.Put(\"UserLogin\",Null)";
[self->__webapiauthbase Put:(NSObject*)(@"UserLogin") :nil];
B4IRDebugUtils.currentLine=3276807;
 //BA.debugLineNum = 3276807;BA.debugLine="WebApiAuthBase.Put(\"GUID_Usr_User\",Null)";
[self->__webapiauthbase Put:(NSObject*)(@"GUID_Usr_User") :nil];
B4IRDebugUtils.currentLine=3276808;
 //BA.debugLineNum = 3276808;BA.debugLine="WebApiAuthBase.Put(\"PK_User\",Null)";
[self->__webapiauthbase Put:(NSObject*)(@"PK_User") :nil];
B4IRDebugUtils.currentLine=3276810;
 //BA.debugLineNum = 3276810;BA.debugLine="WebApiAuthBase.Put(\"IsAdmin\",False)";
[self->__webapiauthbase Put:(NSObject*)(@"IsAdmin") :(NSObject*)(@(false))];
B4IRDebugUtils.currentLine=3276811;
 //BA.debugLineNum = 3276811;BA.debugLine="WebApiAuthBase.Put(\"Roles\",Null)";
[self->__webapiauthbase Put:(NSObject*)(@"Roles") :nil];
B4IRDebugUtils.currentLine=3276812;
 //BA.debugLineNum = 3276812;BA.debugLine="WebApiAuthBase.Put(\"License\",Null)";
[self->__webapiauthbase Put:(NSObject*)(@"License") :nil];
B4IRDebugUtils.currentLine=3276813;
 //BA.debugLineNum = 3276813;BA.debugLine="WebApiAuthBase.Put(\"Modules\",Null)";
[self->__webapiauthbase Put:(NSObject*)(@"Modules") :nil];
B4IRDebugUtils.currentLine=3276814;
 //BA.debugLineNum = 3276814;BA.debugLine="WebApiAuthBase.Put(\"Auths\",Null)";
[self->__webapiauthbase Put:(NSObject*)(@"Auths") :nil];
B4IRDebugUtils.currentLine=3276815;
 //BA.debugLineNum = 3276815;BA.debugLine="WebApiAuthBase.Put(\"Factory\",Null)";
[self->__webapiauthbase Put:(NSObject*)(@"Factory") :nil];
B4IRDebugUtils.currentLine=3276816;
 //BA.debugLineNum = 3276816;BA.debugLine="WebApiAuthBase.Put(\"Module\",Null)";
[self->__webapiauthbase Put:(NSObject*)(@"Module") :nil];
B4IRDebugUtils.currentLine=3276817;
 //BA.debugLineNum = 3276817;BA.debugLine="WebApiAuthBase.Put(\"Area\",Null)";
[self->__webapiauthbase Put:(NSObject*)(@"Area") :nil];
B4IRDebugUtils.currentLine=3276818;
 //BA.debugLineNum = 3276818;BA.debugLine="WebApiAuthBase.Put(\"Geo\",Null)";
[self->__webapiauthbase Put:(NSObject*)(@"Geo") :nil];
B4IRDebugUtils.currentLine=3276819;
 //BA.debugLineNum = 3276819;BA.debugLine="WebApiAuthBase.Put(\"Version\",\"3.0.0\")";
[self->__webapiauthbase Put:(NSObject*)(@"Version") :(NSObject*)(@"3.0.0")];
B4IRDebugUtils.currentLine=3276820;
 //BA.debugLineNum = 3276820;BA.debugLine="WebApiAuthBase.Put(\"CallerType\",1) 'da mettere se";
[self->__webapiauthbase Put:(NSObject*)(@"CallerType") :(NSObject*)(@(1))];
B4IRDebugUtils.currentLine=3276821;
 //BA.debugLineNum = 3276821;BA.debugLine="End Sub";
return @"";
}
- (NSString*)  _iisapidone:(NSString*) _jobname{
B4IRDebugUtils.currentModule=@"main";
if ([B4IDebug shouldDelegate: @"iisapidone"])
	 {return ((NSString*) [B4IDebug delegate:self.bi :@"iisapidone:" :@[[B4I nilToNSNull:_jobname]]]);}
B4IMap* _map1 = nil;
B4IRDebugUtils.currentLine=3538944;
 //BA.debugLineNum = 3538944;BA.debugLine="Sub IISAPIDone(JobName As String)";
B4IRDebugUtils.currentLine=3538945;
 //BA.debugLineNum = 3538945;BA.debugLine="Dim map1 As Map";
_map1 = [B4IMap new];
B4IRDebugUtils.currentLine=3538947;
 //BA.debugLineNum = 3538947;BA.debugLine="If IIS.IsInError = False Then";
if ([self->__iis _isinerror:nil]==false) { 
B4IRDebugUtils.currentLine=3538948;
 //BA.debugLineNum = 3538948;BA.debugLine="map1.Initialize";
[_map1 Initialize];
B4IRDebugUtils.currentLine=3538949;
 //BA.debugLineNum = 3538949;BA.debugLine="map1 = IIS.GiveMeData";
_map1 = [self->__iis _givemedata:nil];
B4IRDebugUtils.currentLine=3538951;
 //BA.debugLineNum = 3538951;BA.debugLine="Select Case JobName";
switch ([self.bi switchObjectToInt:_jobname :@[@"JobLoadPrerequisites"]]) {
case 0: {
B4IRDebugUtils.currentLine=3538953;
 //BA.debugLineNum = 3538953;BA.debugLine="Log(\"ciao\")";
[self->___c LogImpl:@"43538953" :@"ciao" :0];
 break; }
}
;
 };
B4IRDebugUtils.currentLine=3538957;
 //BA.debugLineNum = 3538957;BA.debugLine="End Sub";
return @"";
}
- (NSString*)  _page1_resize:(int) _width :(int) _height{
B4IRDebugUtils.currentModule=@"main";
if ([B4IDebug shouldDelegate: @"page1_resize"])
	 {return ((NSString*) [B4IDebug delegate:self.bi :@"page1_resize::" :@[@(_width),@(_height)]]);}
B4IRDebugUtils.currentLine=131072;
 //BA.debugLineNum = 131072;BA.debugLine="Private Sub Page1_Resize(Width As Int, Height As I";
B4IRDebugUtils.currentLine=131074;
 //BA.debugLineNum = 131074;BA.debugLine="End Sub";
return @"";
}

- (void)initializeStaticModules {
    [[b4i_main new]initializeModule];
[[b4i_httputils2service new]initializeModule];

}
- (NSString*)  _process_globals{
self->__httputils2service=[b4i_httputils2service new];
B4IRDebugUtils.currentModule=@"main";
if ([B4IDebug shouldDelegate: @"process_globals"])
	 {return ((NSString*) [B4IDebug delegate:self.bi :@"process_globals" :nil]);}
B4IRDebugUtils.currentLine=0;
 //BA.debugLineNum = 0;BA.debugLine="Sub Process_Globals";
B4IRDebugUtils.currentLine=3;
 //BA.debugLineNum = 3;BA.debugLine="Public App As Application";
self->__app = [B4IApplicationWrapper new];
B4IRDebugUtils.currentLine=4;
 //BA.debugLineNum = 4;BA.debugLine="Public NavControl As NavigationController";
self->__navcontrol = [B4INavigationControllerWrapper new];
B4IRDebugUtils.currentLine=5;
 //BA.debugLineNum = 5;BA.debugLine="Private Page1 As Page";
self->__page1 = [B4IPage new];
B4IRDebugUtils.currentLine=7;
 //BA.debugLineNum = 7;BA.debugLine="Private IIS As IISApiCall";
self->__iis = [b4i_iisapicall new];
B4IRDebugUtils.currentLine=9;
 //BA.debugLineNum = 9;BA.debugLine="Private WebApiAuthBase As Map";
self->__webapiauthbase = [B4IMap new];
B4IRDebugUtils.currentLine=11;
 //BA.debugLineNum = 11;BA.debugLine="End Sub";
return @"";
}
@end